--TODO: Make it work with automatic fire.
CustomAkimboShotgunBase = CustomAkimboShotgunBase or class(AkimboWeaponBase)
CustomAkimboShotgunBase.AKIMBO = true
function CustomAkimboShotgunBase:init(...)
	CustomAkimboShotgunBase.super.init(self, ...)
	self._unit:set_extension_update_enabled(Idstring("base"), true)
	self._fire_callbacks = {}
	self._use_shotgun_reload = false
end
function CustomAkimboShotgunBase:update(unit, t, dt)
	for i = #self._fire_callbacks, 1, -1 do
		local data = self._fire_callbacks[i]
		data.t = data.t - dt
		if data.t <= 0 then
			data.callback(self)
			table.remove(self._fire_callbacks, i)
		end
	end
end
function CustomAkimboShotgunBase:_create_second_gun(unit_name)
	local factory_weapon = tweak_data.weapon.factory[self._factory_id]
	local ids_unit_name = Idstring(factory_weapon.unit)
	local new_unit = World:spawn_unit(ids_unit_name, Vector3(), Rotation())
	new_unit:base():set_factory_data(self._factory_id)
	if self._cosmetics_id then
		new_unit:base():set_cosmetics_data({
			id = self._cosmetics_id,
			quality = self._cosmetics_quality,
			bonus = self._cosmetics_bonus
		})
	end
	if self._blueprint then
		new_unit:base():assemble_from_blueprint(self._factory_id, self._blueprint)
	elseif not unit_name then
		new_unit:base():assemble(self._factory_id)
	end
	self._second_gun = new_unit
	self._second_gun:base().SKIP_AMMO = true
	self._second_gun:base().parent_weapon = self._unit
	new_unit:base():setup(self._setup)
	self.akimbo = true
	if self._enabled then
		self._second_gun:base():on_enabled()
	else
		self._second_gun:base():on_disabled()
	end
end
function CustomAkimboShotgunBase:toggle_firemode(skip_post_event)
	if CustomAkimboShotgunBase.super.toggle_firemode(self, skip_post_event) then
		if alive(self._second_gun) then
			return self._second_gun:base():toggle_firemode(true)
		else
			return true
		end
	end
	return false
end
function CustomAkimboShotgunBase:create_second_gun(create_second_gun)
	self:_create_second_gun(create_second_gun)
	self._setup.user_unit:camera()._camera_unit:link(Idstring("a_weapon_left"), self._second_gun, self._second_gun:orientation_object():name())
end
function CustomAkimboShotgunBase:start_shooting()
	CustomAkimboShotgunBase.super.start_shooting(self)
	self._fire_second_sound = not self._fire_second_gun_next and self:fire_mode() ~= "auto"
end
function CustomAkimboShotgunBase:fire(...)
	self._fire_second_gun_next = false
	return CustomAkimboShotgunBase.super.fire(self, ...)
end
function CustomAkimboShotgunBase:_fire_second(params)
	if alive(self._second_gun) and self._setup and alive(self._setup.user_unit) then
		local fired = self._second_gun:base().super.fire(self._second_gun:base(), unpack(params))
		if fired then
			if self._fire_second_sound then
				self._fire_second_sound = false
				self._second_gun:base():_fire_sound()
			end
			managers.hud:set_ammo_amount(self:selection_index(), self:ammo_info())
			self._second_gun:base():tweak_data_anim_play("fire")
		end
		return fired
	end
end
function CustomAkimboShotgunBase:on_enabled(...)
	CustomAkimboShotgunBase.super.on_enabled(self, ...)
	if alive(self._second_gun) then
		self._second_gun:base():on_enabled(...)
	end
end
function CustomAkimboShotgunBase:on_disabled(...)
	CustomAkimboShotgunBase.super.on_disabled(self, ...)
	if alive(self._second_gun) then
		self._second_gun:base():on_disabled(...)
	end
end
function CustomAkimboShotgunBase:set_gadget_on(...)
	CustomAkimboShotgunBase.super.set_gadget_on(self, ...)
	if alive(self._second_gun) then
		self._second_gun:base():set_gadget_on(...)
	end
end
function CustomAkimboShotgunBase:_second_gun_tweak_data_anim_version(anim)
	if not self:weapon_tweak_data().animations.second_gun_versions then
		return anim
	end
	return self:weapon_tweak_data().animations.second_gun_versions[anim] or anim
end
function CustomAkimboShotgunBase:tweak_data_anim_play(anim, ...)
	if alive(self._second_gun) and anim ~= "fire" then
		local second_gun_anim = self:_second_gun_tweak_data_anim_version(anim)
		self._second_gun:base():tweak_data_anim_play(second_gun_anim, ...)
	end
	return CustomAkimboShotgunBase.super.tweak_data_anim_play(self, anim, ...)
end
function CustomAkimboShotgunBase:tweak_data_anim_stop(anim, ...)
	CustomAkimboShotgunBase.super.tweak_data_anim_stop(self, anim, ...)
	if alive(self._second_gun) then
		local second_gun_anim = self:_second_gun_tweak_data_anim_version(anim)
		self._second_gun:base():tweak_data_anim_stop(second_gun_anim, ...)
	end
end
function CustomAkimboShotgunBase:destroy(...)
	CustomAkimboShotgunBase.super.destroy(self, ...)
	if alive(self._second_gun) then
		self._second_gun:set_slot(0)
	end
end